﻿using AAT.Common.BO;
using AAT.Common.DAL;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AAT.Common.BLL
{
   class FeeAuthorizationLogic
   {
      public static FeeAuthorization GetFeeAuthorizationByUAK(string UAK)
      {
         if (string.IsNullOrEmpty(UAK)) return null;

         int sta3n = 0;
         string feeAuthorizationIEN = string.Empty;
         string patientIEN = string.Empty;

         string[] strArray = UAK.Split('+');
         if (strArray != null)
         {
            if (strArray.Length > 0) int.TryParse(strArray[0], out sta3n);
            if (strArray.Length > 1) feeAuthorizationIEN = strArray[1];
            if (strArray.Length > 2) patientIEN = strArray[2];
         }

         if (sta3n <= 0 || string.IsNullOrEmpty(feeAuthorizationIEN) || string.IsNullOrEmpty(patientIEN)) return null;


         FeeAuthorizationDb db = new FeeAuthorizationDb();
         return db.GetFeeAuthorizationByUAK(sta3n, feeAuthorizationIEN, patientIEN);
      }

      public static FeeAuthorization GetFeeAuthorizationByPVS(int PatientSID, int FeeVendorSID, DateTime FromDate, DateTime ToDate)
      {
         FeeAuthorizationDb db = new FeeAuthorizationDb();
         return db.GetFeeAuthorizationByPVS(PatientSID, FeeVendorSID, FromDate, ToDate);
      }

   }
} 
