using System;
using System.Collections.Generic;
using System.Text;
using System.Data.SqlClient;
using System.Configuration;
using System.Windows.Forms;

namespace AAT.Common.DAL
{
	public static class DBUtils
	{

       public static void LogEvent(TextBox txtLog, string LogContent)
       {
          txtLog.Text = txtLog + "\r\n" + LogContent;
       }

       public static void LogEvent(string LogContent)
       {
          //System.Diagnostics.EventLog.WriteEntry("AATService", LogContent, System.Diagnostics.EventLogEntryType.Information);

          using (SqlConnection conn = new SqlConnection(Properties.Settings.Default.AATConnection))
          {
             conn.Open();

             using (SqlCommand cmd = new SqlCommand("INSERT INTO EventLog(LogContent) VALUES(@LogContent)", conn))
             {
                cmd.Parameters.AddWithValue("@LogContent", LogContent);
                cmd.ExecuteNonQuery();
             }
          }
       }

       public static void ClearLog()
       {
          using (SqlConnection conn = new SqlConnection(Properties.Settings.Default.AATConnection))
          {
             conn.Open();

             using (SqlCommand cmd = new SqlCommand("DELETE FROM EventLog", conn))
             {
                cmd.ExecuteNonQuery();
             }
          }
       }

       public static string GetLog()
       {
          StringBuilder sb = new StringBuilder();
          using (SqlConnection conn = new SqlConnection(Properties.Settings.Default.AATConnection))
          {
             conn.Open();

             using (SqlCommand cmd = new SqlCommand("SELECT Entered, LogContent FROM EventLog ORDER BY ID", conn))
             {
                using (SqlDataReader reader = cmd.ExecuteReader())
                {
                   while (reader.Read())
                   {
                      sb.AppendLine(reader["Entered"].ToString() + " - " + reader["LogContent"].ToString());
                   }
                }
             }
          }
          return sb.ToString();
       }


       //public void AddToArray<t>(ref t[] arrObject, t obj)
       //{
       //   if (arrObject == null)
       //   {
       //      arrObject = (t[])Array.CreateInstance(typeof(t), 1);
       //   }
       //   else
       //   {
       //      Array.Resize(ref arrObject, arrObject.Length + 1);
       //   }

       //   arrObject.SetValue(obj, arrObject.GetUpperBound(0));
       //}

       //public object GetNullableObject(object obj)
       //{
       //   object objReturn = null;

       //   try
       //   {
       //      if (!(obj is DBNull))
       //      {
       //         objReturn = obj;
       //      }
       //   }
       //   catch { }

       //   return objReturn;
       //}



      public static int GetIntValue(object obj)
      {
         if (obj != null)
         {
            return Convert.ToInt32(obj);
         }
         return 0;
      }

      public static string GetStringValue(object obj)
      {
         if (obj != null)
         {
            return obj.ToString();
         }
         return "";
      }

      public static DateTime? GetDateValue(object obj)
      {
         DateTime? nullDate = null;
         if (obj != null)
         {
            return Convert.ToDateTime(obj);
         }
         return nullDate;
      }
	}
}
