﻿using AAT.Common.BLL;
using AAT.Common.BO;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;

namespace AAT.Common.DAL
{
   class FeeAuthorizationDb
   {

      public FeeAuthorization GetFeeAuthorizationByUAK(int Sta3n, string FeeAuthorizationIEN, string PatientIEN)
      {
         FeeAuthorization feeAuthorization = new FeeAuthorization();

         using (SqlConnection conn = new SqlConnection(Properties.Settings.Default.AATConnection))
         {
            conn.Open();

            using (SqlCommand cmd = new SqlCommand("dbo.usp_GetFeeAuthorizationByUAK", conn))
            {
               cmd.CommandType = CommandType.StoredProcedure;

               cmd.Parameters.AddWithValue("@Sta3n", Sta3n);
               cmd.Parameters.AddWithValue("@FeeAuthorizationIEN", FeeAuthorizationIEN);
               cmd.Parameters.AddWithValue("@PatientIEN", PatientIEN);

               using (SqlDataReader reader = cmd.ExecuteReader())
               {
                  if (reader.Read())
                  {
                     return ParseFeeAuthorization(reader);
                  }
               }
            }
         }

         return null;
      }


      public FeeAuthorization GetFeeAuthorizationByPVS(int PatientSID, int FeeVendorSID, DateTime FromDate, DateTime ToDate)
      {
         FeeAuthorization feeAuthorization = new FeeAuthorization();

         using (SqlConnection conn = new SqlConnection(Properties.Settings.Default.AATConnection))
         {
            conn.Open();

            using (SqlCommand cmd = new SqlCommand("dbo.usp_GetFeeAuthorizationByPVS", conn))
            {
               cmd.CommandType = CommandType.StoredProcedure;

               cmd.Parameters.AddWithValue("@PatientSID", PatientSID);
               cmd.Parameters.AddWithValue("@FeeVendorSID", FeeVendorSID);
               cmd.Parameters.AddWithValue("@FromDate", FromDate);
               cmd.Parameters.AddWithValue("@ToDate", ToDate);
               using (SqlDataReader reader = cmd.ExecuteReader())
               {
                  if (reader.Read())
                  {
                     return ParseFeeAuthorization(reader);
                  }
               }
            }
         }

         return null;
      }


      private FeeAuthorization ParseFeeAuthorization(SqlDataReader dr)
      {
         FeeAuthorization feeAuthorization = new FeeAuthorization();
         feeAuthorization.FeeAuthorizationSID = DBUtils.GetIntValue(dr["FeeAuthorizationSID"]);
         feeAuthorization.FeeAuthorizationIEN = DBUtils.GetStringValue(dr["FeeAuthorizationIEN"]);
         feeAuthorization.PatientSID = DBUtils.GetIntValue(dr["PatientSID"]);
         feeAuthorization.PatientIEN = DBUtils.GetStringValue(dr["PatientIEN"]);
         feeAuthorization.Sta3n = DBUtils.GetIntValue(dr["Sta3n"]);
         feeAuthorization.FromDate = DBUtils.GetDateValue(dr["FromDate"]);
         feeAuthorization.ToDate = DBUtils.GetDateValue(dr["ToDate"]);
         feeAuthorization.FeeProgramSID = DBUtils.GetIntValue(dr["FeeProgramSID"]);
         feeAuthorization.FeeVendorSID = DBUtils.GetIntValue(dr["FeeVendorSID"]);

         // set SPatient
         if (DBUtils.GetIntValue(dr["PatientSID"]) > 0)
         {
            feeAuthorization.SPatient = SPatientLogic.GetPatientById(DBUtils.GetIntValue(dr["PatientSID"]));
         }
         
         return feeAuthorization;
      }
   }
}
