﻿using AAT.Common.BO;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;

namespace AAT.Common.DAL
{
   class InstitutionDb
   {
      public Institution GetInstitutionById(int Sta3n)
      {
         Institution institution = new Institution();

         using (SqlConnection conn = new SqlConnection(Properties.Settings.Default.AATConnection))
         {
            conn.Open();

            using (SqlCommand cmd = new SqlCommand("dbo.usp_GetInstitutionById", conn))
            {
               cmd.CommandType = CommandType.StoredProcedure;

               cmd.Parameters.AddWithValue("@Sta3n", Sta3n);

               using (SqlDataReader reader = cmd.ExecuteReader())
               {
                  if (reader.Read())
                  {
                     return ParseInstitution(reader);
                  }
               }
            }
         }

         return null;
      }



      private Institution ParseInstitution(SqlDataReader dr)
      {
         Institution institution = new Institution();

         institution.InstitutionSID = DBUtils.GetIntValue(dr["InstitutionSID"]);
         institution.InstitutionIEN = DBUtils.GetStringValue(dr["InstitutionIEN"]);
         institution.Sta3n = DBUtils.GetIntValue(dr["Sta3n"]);
         institution.InstitutionName = DBUtils.GetStringValue(dr["InstitutionName"]);
         institution.StreetAddress1 = DBUtils.GetStringValue(dr["StreetAddress1"]);
         institution.StreetAddress2 = DBUtils.GetStringValue(dr["StreetAddress2"]);
         institution.City = DBUtils.GetStringValue(dr["City"]);
         institution.StateAbbrev = DBUtils.GetStringValue(dr["StateAbbrev"]);
         institution.Zip = DBUtils.GetStringValue(dr["Zip"]);

         return institution;
      }
   }


}
