﻿using AAT.Common.BO;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;

namespace AAT.Common.DAL
{
   class SFeeVendorDb
   {
      public SFeeVendor GetVendorByIDNumber(string IDNumber)
      {
         SFeeVendor sFeeVendor = new SFeeVendor();

         using (SqlConnection conn = new SqlConnection(Properties.Settings.Default.AATConnection))
         {
            conn.Open();

            using (SqlCommand cmd = new SqlCommand("dbo.usp_GetVendorByIDNumber", conn))
            {
               cmd.CommandType = CommandType.StoredProcedure;

               cmd.Parameters.AddWithValue("@IDNumber", IDNumber);

               using (SqlDataReader reader = cmd.ExecuteReader())
               {
                  if (reader.Read())
                  {
                     return ParseSFeeVendor(reader);
                  }
               }
            }
         }
         return null;
      }


      private SFeeVendor ParseSFeeVendor(SqlDataReader dr)
      {
         SFeeVendor sFeeVendor = new SFeeVendor();

         sFeeVendor.FeeVendorSID = DBUtils.GetIntValue(dr["FeeVendorSID"]);
         sFeeVendor.FeeVendorIEN = DBUtils.GetStringValue(dr["FeeVendorIEN"]);
         sFeeVendor.Sta3n = DBUtils.GetIntValue(dr["Sta3n"]);
         sFeeVendor.FeeVendor = DBUtils.GetStringValue(dr["FeeVendor"]);
         sFeeVendor.StreetAddress = DBUtils.GetStringValue(dr["StreetAddress"]);
         sFeeVendor.StreetAddress2 = DBUtils.GetStringValue(dr["StreetAddress2"]);
         sFeeVendor.City = DBUtils.GetStringValue(dr["City"]);
         sFeeVendor.StateSID = DBUtils.GetIntValue(dr["StateSID"]);
         sFeeVendor.StateAbbrev = DBUtils.GetStringValue(dr["StateAbbrev"]);
         sFeeVendor.ZipCode = DBUtils.GetStringValue(dr["ZipCode"]);
         sFeeVendor.NPI = DBUtils.GetStringValue(dr["NPI"]);
         sFeeVendor.IDNumber = DBUtils.GetStringValue(dr["IDNumber"]);
         sFeeVendor.TaxIDSSNIndicator = DBUtils.GetStringValue(dr["TaxIDSSNIndicator"]);
         sFeeVendor.TaxonomyCode = DBUtils.GetStringValue(dr["TaxonomyCode"]);


         return sFeeVendor;
      }

   }

}
