﻿using AAT.Common.BO;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;

namespace AAT.Common.DAL
{
   class SPatientDb
   {
      public SPatient GetPatientByLastNameAndSSN(string PatientLastName, string PatientSSN)
      {
         SPatient sPatient = new SPatient();

         using (SqlConnection conn = new SqlConnection(Properties.Settings.Default.AATConnection))
         {
            conn.Open();

            using (SqlCommand cmd = new SqlCommand("dbo.usp_GetPatientByLastNameAndSSN", conn))
            {
               cmd.CommandType = CommandType.StoredProcedure;

               cmd.Parameters.AddWithValue("@PatientLastName", PatientLastName);
               cmd.Parameters.AddWithValue("@PatientSSN", PatientSSN);


               using (SqlDataReader reader = cmd.ExecuteReader())
               {
                  if (reader.Read())
                  {
                     return ParseSPatient(reader);
                  }
               }
            }
         }

         return null;
      }


      public SPatient GetPatientByNameAndDOB(string PatientLastName, string PatientFirstName, DateTime? DateOfBirth)
      {
         SPatient sPatient = new SPatient();

         using (SqlConnection conn = new SqlConnection(Properties.Settings.Default.AATConnection))
         {
            conn.Open();

            using (SqlCommand cmd = new SqlCommand("dbo.usp_GetPatientByNameAndDOB", conn))
            {
               cmd.CommandType = CommandType.StoredProcedure;

               cmd.Parameters.AddWithValue("@PatientLastName", PatientLastName);
               cmd.Parameters.AddWithValue("@PatientFirstName", PatientFirstName);
               cmd.Parameters.AddWithValue("@DateOfBirth", DateOfBirth);


               using (SqlDataReader reader = cmd.ExecuteReader())
               {
                  if (reader.Read())
                  {
                     return ParseSPatient(reader);
                  }
               }
            }
         }
         return null;
      }


      public SPatient GetPatientById(int PatientSID)
      {
         SPatient sPatient = new SPatient();

         using (SqlConnection conn = new SqlConnection(Properties.Settings.Default.AATConnection))
         {
            conn.Open();

            using (SqlCommand cmd = new SqlCommand("dbo.usp_GetPatientById", conn))
            {
               cmd.CommandType = CommandType.StoredProcedure;

               cmd.Parameters.AddWithValue("@PatientSID", PatientSID);

               using (SqlDataReader reader = cmd.ExecuteReader())
               {
                  if (reader.Read())
                  {
                     return ParseSPatient(reader);
                  }
               }
            }
         }
         return null;
      }





      private SPatient ParseSPatient(SqlDataReader dr)
      {
         SPatient sPatient = new SPatient();

         sPatient.PatientSID = DBUtils.GetIntValue(dr["PatientSID"]);
         sPatient.PatientIEN = DBUtils.GetStringValue(dr["PatientIEN"]);
         sPatient.Sta3n = DBUtils.GetIntValue(dr["Sta3n"]);
         sPatient.PatientFirstName = DBUtils.GetStringValue(dr["PatientFirstName"]);
         sPatient.PatientLastName = DBUtils.GetStringValue(dr["PatientLastName"]);
         sPatient.PatientSSN = DBUtils.GetStringValue(dr["PatientSSN"]);
         sPatient.StreetAddress1 = DBUtils.GetStringValue(dr["StreetAddress1"]);
         sPatient.StreetAddress2 = DBUtils.GetStringValue(dr["StreetAddress2"]);
         sPatient.StreetAddress3 = DBUtils.GetStringValue(dr["StreetAddress3"]);
         sPatient.City = DBUtils.GetStringValue(dr["City"]);
         sPatient.State = DBUtils.GetStringValue(dr["State"]);
         sPatient.PostalCode = DBUtils.GetStringValue(dr["PostalCode"]);
         sPatient.Country = DBUtils.GetStringValue(dr["Country"]);
         sPatient.DateOfBirth = DBUtils.GetDateValue(dr["DateOfBirth"]);
         sPatient.Gender = DBUtils.GetStringValue(dr["Gender"]);
         sPatient.EnteredIntoFileDate = DBUtils.GetDateValue(dr["EnteredIntoFileDate"]);
         sPatient.LastUpdated = DBUtils.GetDateValue(dr["LastUpdated"]);
         sPatient.VistaName = DBUtils.GetStringValue(dr["VistaName"]);

         return sPatient;
      }
   }



}
