﻿


using AAT.Common.BLL;
using AAT.Common.BO;
using AAT.Common.DAL;
using ClientApp.Common.BLL;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Security;
using System.Net.Sockets;
using System.Reflection;
using System.Security.Authentication;
using System.Security.Cryptography.X509Certificates;
using System.Text;
using System.Windows.Forms;
using X12Engine.BLL.X12._278;
using X12Engine.BO.X12._278;
using X215 = X12Engine.BO.X12._278._005010X215;
using X217 = X12Engine.BO.X12._278._005010X217;

namespace ClientApp
{

   public partial class TestingForm : Form
   {
      public TestingForm()
      {
         InitializeComponent();
         txtRequest.Text = File.ReadAllText(@"C:\AAT\X217RQ-Testtrans01.txt");
      }

      public string Server = "127.0.0.1";  //192.168.0.3

      private void btnTest_Click_xxx(object sender, EventArgs e)
      {

         //ListCertificates();
         //return;

         DBUtils.ClearLog();
         // Set control number ????
         int controlNumber = 0;
         controlNumber++;
         string req = txtRequest.Text.Replace("\r", "").Replace("\n", "");
         string request = string.Format("{0:D6}{1}", controlNumber, req);
         string sSize = string.Format("{0:D6}", request.Length);
         request = String.Format("{0}{1}", sSize, request);


         // Connect to server port
         IPAddress iPAddress = IPAddress.Parse(Server);
         IPEndPoint serverEndPoint = new IPEndPoint(iPAddress, 3000);   // 192.168.0.3
         TcpClient client = new TcpClient();
         client.Connect(serverEndPoint);

         // Set certificate
         X509CertificateCollection fCollection = new X509CertificateCollection(new X509Certificate[] { GetLocalCertificate() });


         // Send request stream
         SslStream sslStream = new SslStream(client.GetStream(), false, RemoteCertificateValidation, null);
         sslStream.AuthenticateAsClient(Server, fCollection, SslProtocols.Tls, false);
         sslStream.Write(Encoding.ASCII.GetBytes(request));
         sslStream.Flush();

         // Read message from the server.
         byte[] buffer = new byte[2048];
         StringBuilder response = new StringBuilder();
         int bytes = -1;
         do
         {
            bytes = sslStream.Read(buffer, 0, buffer.Length);

            // Use Decoder class to convert from bytes to UTF8 in case a character spans two buffers.
            Decoder decoder = Encoding.UTF8.GetDecoder();
            char[] chars = new char[decoder.GetCharCount(buffer, 0, bytes)];
            decoder.GetChars(buffer, 0, bytes, chars, 0);
            response.Append(chars);

         } while (bytes != 0);
         client.Close();

         txtResponse.Text = response.ToString().Replace("~","\r\n");

         // Get debug log
         txtLog.Text = DBUtils.GetLog();

      }


		private void cmdSend_Click(object sender, EventArgs e)
		{
			DBUtils.ClearLog();
			int controlNumber = 1;

			string req = txtRequest.Text.Replace("\r", "").Replace("\n", "");

			string request = string.Format("{0:D6}{1}", controlNumber, req);
			string sSize = string.Format("{0:D6}", request.Length);
			request = String.Format("{0}{1}", sSize, request);

			using (Stream s = GenerateStreamFromString(request))
			{
				int sta3n = 0;
				int requestID = 0;
				int feeAuthorizationSID = 0;
				string messageText = ProcessRequest(s, ref requestID, ref feeAuthorizationSID, ref sta3n).Replace("~", "~\r\n");
				txtResponse.Text = messageText;


				//Log Response // FS-278-2.0-002   //FS-278-2.0-004  //FS-278-2.0-013
				Response response = new Response();
				response.Sta3n = sta3n;
				response.RequestID = requestID;
				response.MessageText = messageText;
				response.FeeAuthorizationSID = feeAuthorizationSID;
				ResponseLogic.Save(response);
			}

			// Get debug log requestID
			txtLog.Text = DBUtils.GetLog();
		}



		private string ProcessRequest(Stream message, ref int requestID, ref int feeAuthorizationSID, ref int sta3n)
      {
         string messageIn = string.Empty;
         string messageOut = string.Empty;
         string clientIP = string.Empty;

         int messageSize = 0;
         int controlNumber = 0;
         MessageBase messageBase = null;

         using (StreamReader reader = new StreamReader(message))
         {
            char[] sizeBuffer = new char[6];
            reader.ReadBlock(sizeBuffer, 0, 6);
            string sizeIn = new string(sizeBuffer);

            if (!int.TryParse(sizeIn, out messageSize))
            {
            }
            else
            {
               char[] messageBuffer = new char[messageSize];
               reader.ReadBlock(messageBuffer, 0, messageSize);
               messageIn = new string(messageBuffer);

               //The second 6 bytes of the message contain the control number
               string controlIn = string.Empty;
               if (messageIn.Length >= 6)
               {
                  controlIn = messageIn.Substring(0, 6);
                  int.TryParse(controlIn, out controlNumber);

                  //Remove control number from request
                  messageIn = messageIn.Substring(6);
               }

               //Log the request - // FS-278-2.0-001  // FS-278-2.0-003
               Request request = new Request();
               request.RequestReceived = DateTime.Now;
               request.MessageText = sizeIn + controlIn + messageIn;
               request.HCCHRequestID = controlNumber;
               request.UAK = "";
               request.RequestID = requestID = RequestLogic.Save(request);


               //********************************************************* Parse the request - prevalidate segments  *******************************
               messageBase = MessageBaseManager.Parse(messageIn);

               if (messageBase == null)
               {
                  DBUtils.LogEvent(txtLog, "MessageBase is null");

               }
               else if (!messageBase.ValidateMessage())
               {

                  messageBase.FormatError();
                  return messageBase.ToString();
               } 
               else
               {
                  bool blnConfirmedAuthorization = false;
                  bool blnConfirmedPatient = false;
                  bool blnConfirmedVendor = false;

                  //Key authorization values
                  string uak = string.Empty;
                  DateTime? issueDate = null;
                  DateTime? fromDate = null;
                  DateTime? toDate = null;

                  //Key patient values
                  string lastName = string.Empty;
                  string firstName = string.Empty;
                  string ssn = string.Empty;
                  DateTime? dateOfBirth = null;

                  //Key vendor values
                  string vendorIdNumber = string.Empty;
                  string vendorName = string.Empty;

                  //Lookup key values from the request  UAK contains sta3n, feeAuthorizationIEN, patientIEN
                  uak = messageBase.GetUAK();

                  // Validate UAK


                  messageBase.GetLookupDates(ref issueDate, ref fromDate, ref toDate);
                  messageBase.GetPatientInfo(ref lastName, ref firstName, ref ssn, ref dateOfBirth);
                  messageBase.GetVendorInfo(ref vendorIdNumber, ref vendorName);

                  DBUtils.LogEvent("uak=" + uak + "\r\nlastName=" + lastName + "\r\nfirstName=" + firstName + "\r\nssn=" + ssn + "\r\ndateOfBirth=" + dateOfBirth + "\r\nissueDate=" + issueDate + "\r\nfromDate=" + fromDate + "\r\ntoDate=" + toDate + "\r\nvendorIdNumber=" + vendorIdNumber);


                  //Search AAT database based on key values from the request
                  //FS-278-2.0-012 //FS-278-3.0-015
                  FeeAuthorization feeAuthorization = FeeAuthorizationLogic.GetFeeAuthorizationByUAK(uak);
                  SPatient sPatient = SPatientLogic.GetPatientByLastNameAndSSN(lastName, ssn);
                  if (sPatient == null) sPatient = SPatientLogic.GetPatientByNameAndDOB(lastName, firstName, dateOfBirth);
                  SFeeVendor sFeeVendor = SFeeVendorLogic.GetVendorByIDNumber(vendorIdNumber);


                  //Add patient, vendor, and dates to request object and save/update - //FS-278-2.0-011
                  if (sPatient != null) request.PatientSID = sPatient.PatientSID;
                  if (sFeeVendor != null) request.FeeVendorSID = sFeeVendor.FeeVendorSID;
                  if (fromDate != null) request.StartDate = fromDate.Value;
                  if (toDate != null) request.EndDate = toDate.Value;
                  request.UAK = uak;
                  request.RequestID = requestID = RequestLogic.Save(request);

                  //Found Authorization by UAK, confirm Patient and Provider
                  if (feeAuthorization != null)
                  {
                     if (sPatient != null && sPatient.PatientSID == feeAuthorization.PatientSID) blnConfirmedPatient = true;
                     if (sFeeVendor != null && sFeeVendor.FeeVendorSID == feeAuthorization.FeeVendorSID) blnConfirmedVendor = true;
                     if (blnConfirmedPatient && blnConfirmedVendor) {
                        blnConfirmedAuthorization = true;
                     } else {
                        feeAuthorization = null;
                     }
          
                  }

                  //Authorization was not found or not confirmed, lookup Authorization by demographics
                  if (feeAuthorization == null || !blnConfirmedAuthorization)
                  {
                     if (sPatient != null && sFeeVendor != null)
                     {
                        feeAuthorization = FeeAuthorizationLogic.GetFeeAuthorizationByPVS(DBUtils.GetIntValue(sPatient.PatientSID), DBUtils.GetIntValue(sFeeVendor.FeeVendorSID), fromDate.GetValueOrDefault(), toDate.GetValueOrDefault());
                     }
                  }


                  if (feeAuthorization == null)
                  {
                     //Authorization Record NOT found, the AAT shall return the appropriate 2000E AAA error response to the 278 Requestor


                  }
                  else
                  {
                     // 
                     feeAuthorizationSID = DBUtils.GetIntValue(feeAuthorization.FeeAuthorizationSID);
                     sta3n = DBUtils.GetIntValue(feeAuthorization.Sta3n);

                     //FS-278-3.0-023
                     if (fromDate != null && feeAuthorization.FromDate != null && fromDate.Value != feeAuthorization.FromDate.Value) { /* TODO: Add AAA and/or Log Error??? */ }
                     if (toDate != null && feeAuthorization.ToDate != null && toDate.Value != feeAuthorization.ToDate.Value) { /* TODO: Add AAA and/or Log Error??? */ }
                     // issueDate is null....if (issueDate != null && feeAuthorization.ISSUED_DATE != null && issueDate.Value != feeAuthorization.ISSUED_DATE.Value) { /* TODO: Add AAA and/or Log Error??? */ }

                     //FS-278-3.0-075-02
                     //This could cause problems with little discrepancies in the name
                     if (!string.IsNullOrEmpty(vendorName) && sFeeVendor != null && vendorName != sFeeVendor.FeeVendor) { /* TODO: Add AAA and/or Log Error??? */ }

                     //End Validation, Format Response
                     Institution institution = null;
                     if (DBUtils.GetIntValue(feeAuthorization.Sta3n) > 0) institution = InstitutionLogic.GetInstitutionById(DBUtils.GetIntValue(feeAuthorization.Sta3n));
                     if (institution != null && DBUtils.GetIntValue(institution.InstitutionSID) > 0 && !string.IsNullOrEmpty(institution.InstitutionName))
                     {
                        //FS-278-3.0-065-01
                        messageBase.UpdateUmoDetail(Convert.ToInt16(DBUtils.GetIntValue(institution.InstitutionSID)), institution.InstitutionName);
                     }

                     //FS-278-3.0-079 //FS-278-3.0-080
                     messageBase.UpdateRequesterDetail();

                     messageBase.UpdateSubscriberDetail();

                     messageBase.UpdateDependentDetail();

                     //FS-278-3.0-155 SD-3.0-155 //FS-278-3.0-156 SD-3.0-156 //FS-278-3.0-157 SD-3.0-166
                     messageBase.UpdatePatientEventDetail(feeAuthorization.UAK, feeAuthorization.FromDate.Value, feeAuthorization.ToDate.Value, feeAuthorization.Services);

                     //FS-278-3.0-174 SD-3.0-236 //FS-278-3.0-175 SD-3.0-237
                     messageBase.UpdateServiceDetail();

                     //This should probably always go last
                     messageBase.FormatForResponse();
                  }

                  //PREPARE RESPONSE MESSAGE FROM X12 OBJECT
                  return messageBase.ToString();


               }
  
            }
         }
         return "error";
      }

      public void PrintObject(Type type, Object request)
      {

         if (request == null)
         {
            MessageBox.Show("object is empty");
            return;
         }

         StringBuilder sb = new StringBuilder();

         // Loop over properties.
         foreach (PropertyInfo propertyInfo in type.GetProperties())
         {
            string name = propertyInfo.Name;
            object value = propertyInfo.GetValue(request, null);

            if (value is int)
            {
               sb.AppendLine("(int) " + name + "=" + value);
            }
            else if (value is string)
            {
               sb.AppendLine("(string) " + name + "=" + value);
            }
            else if (value is DateTime)
            {
               sb.AppendLine("(date) " + name + "=" + value);
            }
            else
            {
               sb.AppendLine("(null) " + name + "=" + value);
            }
         }
         MessageBox.Show(type.Name + "\r\n************************************\r\n" + sb.ToString());

      }

      private void WriteResponse(string MessageText, int RequestID, int FeeAuthorizationSID)
      {

         MemoryStream stream = new MemoryStream();
         using (StreamWriter writer = new StreamWriter(stream))
         {
            writer.Write(MessageText);
            writer.Flush();
         }

         //Log Response
         Response response = new Response();
         response.RequestID = RequestID;
         response.MessageText = MessageText;
         response.FeeAuthorizationSID = FeeAuthorizationSID;
         ResponseLogic.Save(response);
      }


      private X509Certificate GetLocalCertificate()
      {
         X509Certificate certificate = null;

         X509Store store = null;
         try
         {
            store = new X509Store(StoreName.My, StoreLocation.CurrentUser);
            if (store != null)
            {
               store.Open(OpenFlags.ReadOnly);

               X509Certificate2Collection collection = store.Certificates;
               if (collection != null)
               {
                  if (AAT.Properties.Settings.Default.CertSearchBy == "SerialNumber")
                  {
                     X509Certificate2Collection fcollection = collection.Find(X509FindType.FindBySerialNumber, AAT.Properties.Settings.Default.CertSerialNumber, false);
                     if (fcollection != null)
                     {
                        certificate = (X509Certificate)fcollection[0];
                     }
                  }
                  else if (AAT.Properties.Settings.Default.CertSearchBy == "Issuer")
                  {
                     foreach (X509Certificate2 x509 in collection)
                     {
                        if (x509.Issuer.Contains(AAT.Properties.Settings.Default.CertIssuer))
                        {
                           certificate = (X509Certificate)x509;
                           break;
                        }
                     }
                  }
               }
            }
         }
         catch (Exception ex)
         {
            MessageBox.Show(ex.Message);
         }
         finally
         {
            if (store != null)
            {
               store.Close();
               store = null;
            }
         }

         return certificate;
      }


      private X509Certificate SelectLocalCertificate(Object sender, string targetHost, X509CertificateCollection localCertificates, X509Certificate remoteCertificate, string[] acceptableIssuers)
      {
         return GetLocalCertificate();
      }

      private bool RemoteCertificateValidation(Object sender, X509Certificate certificate, X509Chain chain, SslPolicyErrors sslPolicyErrors)
      {
         //TODO: 
         //If the server provides their certificate and the entire chain is
         //added to the clients local trust, you could use this validation
         //because the certificate is trusted by the client
         return (sslPolicyErrors == SslPolicyErrors.None);

         //Or, A list of valid server certificates can be kept somewhere, it could even be a 
         //list of string values, but some type of comparison should happen below
         //X509Certificate localCert = GetLocalCertificate();
         //if (localCert != null && certificate != null)
         //{
         //    if (localCert.GetSerialNumberString() == certificate.GetSerialNumberString()) return true;
         //}

         //return false;
      }



      private void ListCertificates()
      {
         txtRequest.Text = "******************   CurrentUser\r\n";
         X509Store storeCurrentUser = new X509Store(StoreName.My, StoreLocation.CurrentUser);
         storeCurrentUser.Open(OpenFlags.ReadOnly);
         X509Certificate2Collection certificates = storeCurrentUser.Certificates;

         foreach (X509Certificate2 certificate in certificates)
         {
            txtRequest.Text += "\r\nSerialNumber=" + certificate.SerialNumber;
            txtRequest.Text += "\r\nIssuer=" + certificate.Issuer;
         }
         storeCurrentUser.Close();


         txtRequest.Text += "\r\n\r\n" + "******************   LocalMachine\r\n";
         X509Store storeLocalMachine = new X509Store(StoreName.My, StoreLocation.LocalMachine);
         storeLocalMachine.Open(OpenFlags.ReadOnly);
         X509Certificate2Collection certificates2 = storeLocalMachine.Certificates;

         foreach (X509Certificate2 certificate in certificates2)
         {
            txtRequest.Text += "\r\nSerialNumber=" + certificate.SerialNumber;
            txtRequest.Text += "\r\nIssuer=" + certificate.Issuer;
         }
         storeLocalMachine.Close();

      }

      private void cmdClose_Click(object sender, EventArgs e)
      {
         this.Close();
      }


      public Stream GenerateStreamFromString(string s)
      {
         MemoryStream stream = new MemoryStream();
         StreamWriter writer = new StreamWriter(stream);
         writer.Write(s);
         writer.Flush();
         stream.Position = 0;
         return stream;
      }

		private void btnDir_Click(object sender, EventArgs e)
		{
			// Create an instance of the open file dialog box.
			OpenFileDialog openFileDialog1 = new OpenFileDialog();

			// Set filter options and filter index.
			openFileDialog1.Filter = "Text Files (.txt)|*.txt";
			openFileDialog1.FilterIndex = 1;

			openFileDialog1.Multiselect = false;

			// Call the ShowDialog method to show the dialog box.
			DialogResult result = openFileDialog1.ShowDialog();

			// Process input if the user clicked OK.
			if (result == DialogResult.OK)
			{
				string file = openFileDialog1.FileName;
				try
				{
					string text = File.ReadAllText(file);
					txtRequest.Text = text;
				}
				catch (IOException)
				{
				}
			}

		}
	}
}
