﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using X12Engine.BO.X12._278;
using X12Engine.BO.X12._278._005010X215;

namespace X12Engine.BLL.X12._278._005010X215
{
   public static class RequesterDetailManager
   {
      public static RequesterDetail Parse(string loop)
      {
         RequesterDetail objReturn = new RequesterDetail();

         string[] segments = loop.Split(Settings.Segment_Terminator);
         if (segments != null)
         {

            EntityBase requesterName = null;

            foreach (string segment in segments)
            {
               if (string.IsNullOrEmpty(segment)) continue;

               string[] elements = segment.Split(Settings.Data_Element_Separator);
               if (elements != null && !string.IsNullOrEmpty(elements[0]))
               {
                  string segmentId = elements[0].ToUpper();

                  if (segmentId == "HL")
                        objReturn.RequesterLevel = HLManager.Parse(segment);
                  else if (Utils.IsEntitySegment(segmentId))
                  {
                     if (objReturn.RequesterName == null) objReturn.RequesterName = new List<EntityBase>();

                     if (segmentId == "NM1")
                     {
                        if (requesterName != null) objReturn.RequesterName.Add(requesterName);
                        requesterName = new EntityBase();
                     }

                     requesterName = EntityBaseManager.Parse(segment, requesterName);
                  }
                  else
                     objReturn.Other = DetailBaseManager.Parse(segment, objReturn.Other);
               }
            }

            if (requesterName != null) objReturn.RequesterName.Add(requesterName);
         }

         return objReturn;
      }
   }
}
