﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using X12Engine.BO.X12._278;
using X12Engine.BO.X12._278._005010X215;

namespace X12Engine.BLL.X12._278._005010X215
{
   public static class ServiceDetailManager
   {
      public static ServiceDetail Parse(string loop)
      {
         ServiceDetail objReturn = new ServiceDetail();

         string[] segments = loop.Split(Settings.Segment_Terminator);
         if (segments != null)
         {
            EntityBase serviceProviderName = null;

            foreach (string segment in segments)
            {
               if (string.IsNullOrEmpty(segment)) continue;

               string[] elements = segment.Split(Settings.Data_Element_Separator);
               if (elements != null && !string.IsNullOrEmpty(elements[0]))
               {
                  string segmentId = elements[0].ToUpper();
                  string qualifier = elements[1].ToUpper();

                  if (segmentId == "HL")
                        objReturn.ServiceLevel = HLManager.Parse(segment);
                  else if (segmentId == "TRN")
                  {
                     if (objReturn.ServiceTraceNumber == null) objReturn.ServiceTraceNumber = new List<TRN>();
                     objReturn.ServiceTraceNumber.Add(TRNManager.Parse(segment));
                  }
                  //else if (segmentId == "AAA" && !entitySegmentFound)
                  //{
                  //   if (objReturn.ServiceRequestValidation == null) objReturn.ServiceRequestValidation = new List<AAA>();
                  //   objReturn.ServiceRequestValidation.Add(AAAManager.Parse(segment));
                  //}
                  else if (segmentId == "UM")
                        objReturn.HealthCareServicesReviewInformation = UMManager.Parse(segment);
                  else if (segmentId == "HCR")
                        objReturn.HealthCareServicesReview = HCRManager.Parse(segment);
                  else if (segmentId == "REF" && qualifier == "BB")
                        objReturn.PreviousReviewAuthorizationNumber = REFManager.Parse(segment);
                  else if (segmentId == "REF" && qualifier == "NT")
                        objReturn.PreviousReviewAuthorizationNumber = REFManager.Parse(segment);
                  else if (segmentId == "DTP" && qualifier == "472")
                        objReturn.ServiceDate = DTPManager.Parse(segment);
                  else if (segmentId == "DTP" && qualifier == "102")
                        objReturn.CertificationIssueDate = DTPManager.Parse(segment);
                  else if (segmentId == "DTP" && qualifier == "036")
                        objReturn.CertificationExpirationDate = DTPManager.Parse(segment);
                  else if (segmentId == "DTP" && qualifier == "007")
                        objReturn.CertificationEffectiveDate = DTPManager.Parse(segment);
                  else if (segmentId == "SV1")
                        objReturn.ProfessionalService = SV1Manager.Parse(segment);
                  else if (segmentId == "SV2")
                        objReturn.InstitutionalService = SV2Manager.Parse(segment);
                  else if (segmentId == "SV3")
                        objReturn.DentalService = SV3Manager.Parse(segment);
                  else if (segmentId == "TOO")
                  {
                     if (objReturn.ToothInformation == null) objReturn.ToothInformation = new List<TOO>();
                     objReturn.ToothInformation.Add(TOOManager.Parse(segment));
                  }
                  else if (segmentId == "HSD")
                        objReturn.HealthCareServicesDelivery = HSDManager.Parse(segment);
                  else if (segmentId == "MSG")
                        objReturn.MessageText = MSGManager.Parse(segment);
                  else if (Utils.IsEntitySegment(segmentId))
                  {

                     if (objReturn.ServiceProviderName == null) objReturn.ServiceProviderName = new List<EntityBase>();

                     if (segmentId == "NM1")
                     {
                        if (serviceProviderName != null) objReturn.ServiceProviderName.Add(serviceProviderName);
                        serviceProviderName = new EntityBase();
                     }

                     serviceProviderName = EntityBaseManager.Parse(segment, serviceProviderName);
                  }
                  else if (segmentId == "SE")
                  {
                        //do nothing, will be parsed in the main loop
                  }
                  else
                     objReturn.Other = DetailBaseManager.Parse(segment, objReturn.Other);
               }
            }

            if (serviceProviderName != null) objReturn.ServiceProviderName.Add(serviceProviderName);
         }

         return objReturn;
      }
   }
}
