﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using X12Engine.BO.X12._278;
using X12Engine.BO.X12._278._005010X215;

namespace X12Engine.BLL.X12._278._005010X215
{
   public static class SubscriberDetailManager
   {
      public static SubscriberDetail Parse(string loop)
      {
         SubscriberDetail objReturn = new SubscriberDetail();

         string[] segments = loop.Split(Settings.Segment_Terminator);
         if (segments != null)
         {

            foreach (string segment in segments)
            {
               if (string.IsNullOrEmpty(segment)) continue;

               string[] elements = segment.Split(Settings.Data_Element_Separator);
               if (elements != null && !string.IsNullOrEmpty(elements[0]))
               {
                  string segmentId = elements[0].ToUpper();

                  if (segmentId == "HL")
                        objReturn.SubscriberLevel = HLManager.Parse(segment);
                  else if (segmentId == "TRN")
                  {
                     if (objReturn.SubscriberTraceNumber == null) objReturn.SubscriberTraceNumber = new List<TRN>();
                     objReturn.SubscriberTraceNumber.Add(TRNManager.Parse(segment));
                  }
                  else if (Utils.IsEntitySegment(segmentId))
                     objReturn.SubscriberName = EntityBaseManager.Parse(segment, objReturn.SubscriberName);
                  else
                     objReturn.Other = DetailBaseManager.Parse(segment, objReturn.Other);
               }
            }
         }

         return objReturn;
      }
   }
}
