﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using X12Engine.BO.X12._278;
using X12Engine.BO.X12._278._005010X215;

namespace X12Engine.BLL.X12._278._005010X215
{
   public static class UmoDetailManager
   {
      public static UmoDetail Parse(string loop)
      {
         UmoDetail objReturn = new UmoDetail();

         string[] segments = loop.Split(Settings.Segment_Terminator);
         if (segments != null)
         {
            foreach (string segment in segments)
            {
               if (string.IsNullOrEmpty(segment)) continue;

               string[] elements = segment.Split(Settings.Data_Element_Separator);
               if (elements != null && !string.IsNullOrEmpty(elements[0]))
               {
                  string segmentId = elements[0].ToUpper();

                  if (segmentId == "HL")
                     objReturn.UMOLevel = HLManager.Parse(segment);
                  //else if (segmentId == "AAA" && !entitySegmentFound)
                  //{
                  //   if (objReturn.RequestValidation == null) objReturn.RequestValidation = new List<AAA>();
                  //   objReturn.RequestValidation.Add(AAAManager.Parse(segment));
                  //}
                  else if (Utils.IsEntitySegment(segmentId))
                  {
                     objReturn.UMOName = EntityBaseManager.Parse(segment, objReturn.UMOName);
                  }
                  else
                     objReturn.Other = DetailBaseManager.Parse(segment, objReturn.Other);
               }
            }
         }

         return objReturn;
      }
   }
}
