﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using X12Engine.BO.X12._278;
using X12Engine.BO.X12._278._005010X217;

namespace X12Engine.BLL.X12._278._005010X217
{
   public static class DependentDetailManager
   {
      public static DependentDetail Parse(string loop)
      {
         DependentDetail objReturn = new DependentDetail();

         string[] segments = loop.Split(Settings.Segment_Terminator);
         if (segments != null)
         {

            foreach (string segment in segments)
            {
               if (string.IsNullOrEmpty(segment)) continue;

               string[] elements = segment.Split(Settings.Data_Element_Separator);
               if (elements != null && !string.IsNullOrEmpty(elements[0]))
               {
                  string segmentId = elements[0].ToUpper();

                  if (segmentId == "HL")
                     objReturn.DependentLevel = HLManager.Parse(segment);
                  else if (Utils.IsEntitySegment(segmentId))
                     objReturn.DependentName = EntityBaseManager.Parse(segment, objReturn.DependentName);
                  else
                     objReturn.Other = DetailBaseManager.Parse(segment, objReturn.Other);
               }
            }
         }

         return objReturn;
      }
   }
}
