﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using X12Engine.BO.X12._278;

namespace X12Engine.BLL.X12._278
{
   public static class DetailBaseManager
   {
      public static DetailBase Parse(string segment, DetailBase temp)
      {
         DetailBase objReturn = (temp != null) ? temp : objReturn = new DetailBase();

         string[] elements = segment.Split(Settings.Data_Element_Separator);
         if (elements != null)
         {

            string segmentId = elements[0].ToUpper();
            switch (segmentId)
            {
               case "HL":
                  objReturn.HierarchicalLevel = HLManager.Parse(segment);
                  break;
               case "TRN":
                  if (objReturn.Trace == null) objReturn.Trace = new List<TRN>();
                  objReturn.Trace.Add(TRNManager.Parse(segment));
                  break;
               //case "AAA":
               //    if (objReturn.RequestValidation == null) objReturn.RequestValidation = new List<AAA>();
               //    objReturn.RequestValidation.Add(AAAManager.Parse(segment));
               //    break;
               case "UM":
                  objReturn.HealthCareServicesReviewInformation = UMManager.Parse(segment);
                  break;
               case "HCR":
                  objReturn.HealthCareServicesReview = HCRManager.Parse(segment);
                  break;
               case "REF":
                  if (objReturn.ReferenceInformation == null) objReturn.ReferenceInformation = new List<REF>();
                  objReturn.ReferenceInformation.Add(REFManager.Parse(segment));
                  break;
               case "DTP":
                  if (objReturn.DateOrTimeOrPeriod == null) objReturn.DateOrTimeOrPeriod = new List<DTP>();
                  objReturn.DateOrTimeOrPeriod.Add(DTPManager.Parse(segment));
                  break;
               case "HI":
                  objReturn.HealthCareInformationCodes = HIManager.Parse(segment);
                  break;
               case "SV1":
                  objReturn.ProfessionalService = SV1Manager.Parse(segment);
                  break;
               case "SV2":
                  objReturn.InstitutionalService = SV2Manager.Parse(segment);
                  break;
               case "SV3":
                  objReturn.DentalService = SV3Manager.Parse(segment);
                  break;
               case "TOO":
                  if (objReturn.ToothIdentification == null) objReturn.ToothIdentification = new List<TOO>();
                  objReturn.ToothIdentification.Add(TOOManager.Parse(segment));
                  break;
               case "HSD":
                  objReturn.HealthCareServicesDelivery = HSDManager.Parse(segment);
                  break;
               case "CRC":
                  if (objReturn.ConditionsIndicator == null) objReturn.ConditionsIndicator = new List<CRC>();
                  objReturn.ConditionsIndicator.Add(CRCManager.Parse(segment));
                  break;
               case "CL1":
                  objReturn.ClaimCodes = CL1Manager.Parse(segment);
                  break;
               case "CR1":
                  objReturn.AmbulanceCertification = CR1Manager.Parse(segment);
                  break;
               case "CR2":
                  objReturn.ChiropracticCertification = CR2Manager.Parse(segment);
                  break;
               case "CR4":
                  objReturn.EnteralOrParenteralTherapyCertification = CR4Manager.Parse(segment);
                  break;
               case "CR5":
                  objReturn.OxygenTherapyCertification = CR5Manager.Parse(segment);
                  break;
               case "CR6":
                  objReturn.HomeHealthCareCertification = CR6Manager.Parse(segment);
                  break;
               case "CR7":
                  objReturn.HomeHealthTreatmentPlanCertification = CR7Manager.Parse(segment);
                  break;
               case "CR8":
                  objReturn.PacemakerCertification = CR8Manager.Parse(segment);
                  break;
               case "PWK":
                  if (objReturn.Paperwork == null) objReturn.Paperwork = new List<PWK>();
                  objReturn.Paperwork.Add(PWKManager.Parse(segment));
                  break;
               case "MSG":
                  objReturn.MessageText = MSGManager.Parse(segment);
                  break;
               default:
                  break;
            }

         }

         return objReturn;
      }
   }
}
