﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using X12Engine.BO.X12._278;

namespace X12Engine.BLL.X12._278
{
   public static class EntityBaseManager
   {
      public static EntityBase Parse(string segment, EntityBase entityBase)
      {
         EntityBase objReturn = (entityBase != null) ? entityBase : objReturn = new EntityBase();

         string[] elements = segment.Split(Settings.Data_Element_Separator);
         if (elements != null)
         {
            string segmentId = elements[0].ToUpper();
            switch (segmentId)
            {
               case "NM1":
                  objReturn.IndividualOrOrganizationName = NM1Manager.Parse(segment);
                  break;
               case "REF":
                  if (objReturn.ReferenceInformation == null) objReturn.ReferenceInformation = new List<REF>();
                  objReturn.ReferenceInformation.Add(REFManager.Parse(segment));
                  break;
               case "N2":
                  objReturn.AdditionalNameInformation = N2Manager.Parse(segment);
                  break;
               case "N3":
                  objReturn.PartyLocation = N3Manager.Parse(segment);
                  break;
               case "N4":
                  objReturn.GeographicLocation = N4Manager.Parse(segment);
                  break;
               case "PER":
                  if (objReturn.AdministrativeCommunicationsContact == null) objReturn.AdministrativeCommunicationsContact = new List<PER>();
                  objReturn.AdministrativeCommunicationsContact.Add(PERManager.Parse(segment));
                  break;
               //case "AAA":
               //   if (objReturn.RequestValidation == null) objReturn.RequestValidation = new List<AAA>();
               //   objReturn.RequestValidation.Add(AAAManager.Parse(segment));
               //   break;
               case "PRV":
                  objReturn.ProviderInformation = PRVManager.Parse(segment);
                  break;
               case "DMG":
                  objReturn.DemographicInformation = DMGManager.Parse(segment);
                  break;
               case "INS":
                  objReturn.InsuredBenefit = INSManager.Parse(segment);
                  break;
               case "DTP":
                  if (objReturn.DateOrTimeOrPeriod == null) objReturn.DateOrTimeOrPeriod = new List<DTP>();
                  objReturn.DateOrTimeOrPeriod.Add(DTPManager.Parse(segment));
                  break;
               default:
                  break;
            }
         }

         return objReturn;
      }
   }
}
