﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace X12Engine.BO.X12._278._005010X215
{
    [Serializable()]
    public class PatientEventDetail
    {
        #region Fields

        private HL _patientEventLevel;
        private List<TRN> _patientEventTraceNumber;
        private List<AAA> _patientEventRequestValidation;
        private UM _healthCareServicesReviewInformation;
        private HCR _healthCareServicesReview;
        private REF _previousReviewAuthorizationNumber;
        private REF _previousReviewAdministrativeReferenceNumber;
        private DTP _accidentDate;
        private DTP _eventDate;
        private DTP _admissionDate;
        private DTP _dischargeDate;
        private DTP _certificationIssueDate;
        private DTP _certificationExpirationDate;
        private DTP _certificationEffectiveDate;
        private DTP _healthCareServicesReviewRequestDate;
        private HI _patientDiagnosis;
        private HSD _healthCareServicesDelivery;
        private CL1 _institutionalClaimCode;
        private CR1 _ambulanceTransportInformation;
        private CR2 _spinalManipulationServiceInformation;
        private CR5 _homeOxygenTherapyInformation;
        private CR6 _homeHealthCareInformation;
        private MSG _messageText;
        private DetailBase _other;
        private List<EntityBase> _patientEventProviderName;
        private List<EntityBase> _patientEventTransportInformation;

        #endregion

        #region Constructors

        public PatientEventDetail() { }

        #endregion

        #region Properties

        public HL PatientEventLevel
        {
            get { return _patientEventLevel; }
            set { _patientEventLevel = value; }
        }

        public List<TRN> PatientEventTraceNumber
        {
            get { return _patientEventTraceNumber; }
            set { _patientEventTraceNumber = value; }
        }

        public List<AAA> PatientEventRequestValidation
        {
            get { return _patientEventRequestValidation; }
            set { _patientEventRequestValidation = value; }
        }

        public UM HealthCareServicesReviewInformation
        {
            get { return _healthCareServicesReviewInformation; }
            set { _healthCareServicesReviewInformation = value; }
        }

        public HCR HealthCareServicesReview
        {
            get { return _healthCareServicesReview; }
            set { _healthCareServicesReview = value; }
        }

        public REF PreviousReviewAuthorizationNumber
        {
            get { return _previousReviewAuthorizationNumber; }
            set { _previousReviewAuthorizationNumber = value; }
        }

        public REF PreviousReviewAdministrativeReferenceNumber
        {
            get { return _previousReviewAdministrativeReferenceNumber; }
            set { _previousReviewAdministrativeReferenceNumber = value; }
        }

        public DTP AccidentDate
        {
            get { return _accidentDate; }
            set { _accidentDate = value; }
        }

        public DTP EventDate
        {
            get { return _eventDate; }
            set { _eventDate = value; }
        }

        public DTP AdmissionDate
        {
            get { return _admissionDate; }
            set { _admissionDate = value; }
        }

        public DTP DischargeDate
        {
            get { return _dischargeDate; }
            set { _dischargeDate = value; }
        }

        public DTP CertificationIssueDate
        {
            get { return _certificationIssueDate; }
            set { _certificationIssueDate = value; }
        }

        public DTP CertificationExpirationDate
        {
            get { return _certificationExpirationDate; }
            set { _certificationExpirationDate = value; }
        }

        public DTP CertificationEffectiveDate
        {
            get { return _certificationEffectiveDate; }
            set { _certificationEffectiveDate = value; }
        }

        public DTP HealthCareServicesReviewRequestDate
        {
            get { return _healthCareServicesReviewRequestDate; }
            set { _healthCareServicesReviewRequestDate = value; }
        }

        public HI PatientDiagnosis
        {
            get { return _patientDiagnosis; }
            set { _patientDiagnosis = value; }
        }

        public HSD HealthCareServicesDelivery
        {
            get { return _healthCareServicesDelivery; }
            set { _healthCareServicesDelivery = value; }
        }

        public CL1 InstitutionalClaimCode
        {
            get { return _institutionalClaimCode; }
            set { _institutionalClaimCode = value; }
        }

        public CR1 AmbulanceTransportInformation
        {
            get { return _ambulanceTransportInformation; }
            set { _ambulanceTransportInformation = value; }
        }

        public CR2 SpinalManipulationServiceInformation
        {
            get { return _spinalManipulationServiceInformation; }
            set { _spinalManipulationServiceInformation = value; }
        }

        public CR5 HomeOxygenTherapyInformation
        {
            get { return _homeOxygenTherapyInformation; }
            set { _homeOxygenTherapyInformation = value; }
        }

        public CR6 HomeHealthCareInformation
        {
            get { return _homeHealthCareInformation; }
            set { _homeHealthCareInformation = value; }
        }

        public MSG MessageText
        {
            get { return _messageText; }
            set { _messageText = value; }
        }

        public DetailBase Other
        {
            get { return _other; }
            set { _other = value; }
        }

        public List<EntityBase> PatientEventProviderName
        {
            get { return _patientEventProviderName; }
            set { _patientEventProviderName = value; }
        }

        public List<EntityBase> PatientEventTransportInformation
        {
            get { return _patientEventTransportInformation; }
            set { _patientEventTransportInformation = value; }
        }

        #endregion

        #region Methods

        public override string ToString()
        {
            string strReturn = string.Empty;

            //0100
            if (_patientEventLevel != null) strReturn += _patientEventLevel.ToString();

            //0200
            if (_patientEventTraceNumber != null)
            {
                foreach (TRN t in _patientEventTraceNumber)
                {
                    strReturn += t.ToString();
                }
            }

            //0300
            if (_patientEventRequestValidation != null)
            {
                foreach (AAA a in _patientEventRequestValidation)
                {
                    strReturn += a.ToString();
                }
            }

            //0400
            if (_healthCareServicesReviewInformation != null) strReturn += _healthCareServicesReviewInformation.ToString();

            //0500
            if (_healthCareServicesReview != null) strReturn += _healthCareServicesReview.ToString();

            //0600
            if (_previousReviewAuthorizationNumber != null) strReturn += _previousReviewAuthorizationNumber.ToString();

            if (_previousReviewAdministrativeReferenceNumber != null) strReturn += _previousReviewAdministrativeReferenceNumber.ToString();

            if (_other != null) _other.CheckSegment("REF", ref strReturn);

            //0700
            if (_accidentDate != null) strReturn += _accidentDate.ToString();

            if (_eventDate != null) strReturn += _eventDate.ToString();

            if (_admissionDate != null) strReturn += _admissionDate.ToString();

            if (_dischargeDate != null) strReturn += _dischargeDate.ToString();

            if (_certificationIssueDate != null) strReturn += _certificationIssueDate.ToString();

            if (_certificationExpirationDate != null) strReturn += _certificationExpirationDate.ToString();

            if (_certificationEffectiveDate != null) strReturn += _certificationEffectiveDate.ToString();

            if (_healthCareServicesReviewRequestDate != null) strReturn += _healthCareServicesReviewRequestDate.ToString();

            if (_other != null) _other.CheckSegment("DTP", ref strReturn);

            //0800
            if (_patientDiagnosis != null) strReturn += _patientDiagnosis.ToString();

            //0810
            if (_other != null) _other.CheckSegment("SV1", ref strReturn);

            //0820
            if (_other != null) _other.CheckSegment("SV2", ref strReturn);

            //0830
            if (_other != null) _other.CheckSegment("SV3", ref strReturn);

            //0840
            if (_other != null) _other.CheckSegment("TOO", ref strReturn);

            //0900
            if (_healthCareServicesDelivery != null) strReturn += _healthCareServicesDelivery.ToString();

            //1000
            if (_other != null) _other.CheckSegment("CRC", ref strReturn);

            //1100
            if (_institutionalClaimCode != null) strReturn += _institutionalClaimCode.ToString();

            //1200
            if (_ambulanceTransportInformation != null) strReturn += _ambulanceTransportInformation.ToString();

            //1300
            if (_spinalManipulationServiceInformation != null) strReturn += _spinalManipulationServiceInformation.ToString();

            //1350
            if (_other != null) _other.CheckSegment("CR4", ref strReturn);

            //1400
            if (_homeOxygenTherapyInformation != null) strReturn += _homeOxygenTherapyInformation.ToString();

            //1500
            if (_homeHealthCareInformation != null) strReturn += _homeHealthCareInformation.ToString();

            //1520
            if (_other != null) _other.CheckSegment("CR7", ref strReturn);

            //1530
            if (_other != null) _other.CheckSegment("CR8", ref strReturn);

            //1550
            if (_other != null) _other.CheckSegment("PWK", ref strReturn);

            //1600
            if (_messageText != null) strReturn += _messageText.ToString();

            if (_patientEventProviderName != null)
            {
                foreach (EntityBase e in _patientEventProviderName)
                {
                    strReturn += e.ToString();
                }
            }

            if (_patientEventTransportInformation != null)
            {
                foreach (EntityBase e in _patientEventTransportInformation)
                {
                    strReturn += e.ToString();
                }
            }

            return strReturn;
        }

        #endregion
    }
}
