﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace X12Engine.BO.X12._278._005010X217
{
   [Serializable()]
   public class Message
   {

      private ST _transactionSetHeader;
      private BHT _beginningOfHierarchicalTransaction;
      private UmoDetail _umoDetail;
      private RequesterDetail _requesterDetail;
      private List<SubscriberDetail> _subscriberDetail;
      private List<DependentDetail> _dependentDetail;
      private List<PatientEventDetail> _patientEventDetail;
      private List<ServiceDetail> _serviceDetail;
      private SE _transactionSetTrailer;


      public ST TransactionSetHeader
      {
         get { return _transactionSetHeader; }
         set { _transactionSetHeader = value; }
      }

      public BHT BeginningOfHierarchicalTransaction
      {
         get { return _beginningOfHierarchicalTransaction; }
         set { _beginningOfHierarchicalTransaction = value; }
      }

      public UmoDetail UmoDetail
      {
         get { return _umoDetail; }
         set { _umoDetail = value; }
      }

      public RequesterDetail RequesterDetail
      {
         get { return _requesterDetail; }
         set { _requesterDetail = value; }
      }

      public List<SubscriberDetail> SubscriberDetail
      {
         get { return _subscriberDetail; }
         set { _subscriberDetail = value; }
      }

      public List<DependentDetail> DependentDetail
      {
         get { return _dependentDetail; }
         set { _dependentDetail = value; }
      }

      public List<PatientEventDetail> PatientEventDetail
      {
         get { return _patientEventDetail; }
         set { _patientEventDetail = value; }
      }

      public List<ServiceDetail> ServiceDetail
      {
         get { return _serviceDetail; }
         set { _serviceDetail = value; }
      }

      public SE TransactionSetTrailer
      {
         get { return _transactionSetTrailer; }
         set { _transactionSetTrailer = value; }
      }


      public override string ToString()
      {
         string strReturn = string.Empty;

         if (_transactionSetHeader != null) strReturn += _transactionSetHeader.ToString();

         if (_beginningOfHierarchicalTransaction != null) strReturn += _beginningOfHierarchicalTransaction.ToString();

         if (_umoDetail != null) strReturn += _umoDetail.ToString();

         if (_requesterDetail != null) strReturn += _requesterDetail.ToString();

         if (_subscriberDetail != null)
         {
            foreach (SubscriberDetail sd in _subscriberDetail)
            {
               strReturn += sd.ToString();
            }
         }

         if (_dependentDetail != null)
         {
            foreach (DependentDetail dd in _dependentDetail)
            {
               strReturn += dd.ToString();
            }
         }

         if (_patientEventDetail != null)
         {
            foreach (PatientEventDetail ped in _patientEventDetail)
            {
               strReturn += ped.ToString();
            }
         }

         if (_serviceDetail != null)
         {
            foreach (ServiceDetail sd in _serviceDetail)
            {
               strReturn += sd.ToString();
            }
         }

         if (_transactionSetTrailer != null) strReturn += _transactionSetTrailer.ToString();

         return strReturn;
      }

   }
}
