﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using X215 = X12Engine.BO.X12._278._005010X215;
using X217 = X12Engine.BO.X12._278._005010X217;

namespace X12Engine.BO.X12._278
{
   [Serializable()]
   public class MessageBase
   {

      private ISA _interchangeControlHeader;
      private GS _functionalGroupHeader;
      private X215.MessageGroup _x215List;
      private X217.MessageGroup _x217List;
      private GE _functionalGroupTrailer;
      private IEA _interchangeControlTrailer;


      public ISA InterchangeControlHeader
      {
         get { return _interchangeControlHeader; }
         set { _interchangeControlHeader = value; }
      }

      public GS FunctionalGroupHeader
      {
         get { return _functionalGroupHeader; }
         set { _functionalGroupHeader = value; }
      }

      public X215.MessageGroup X215List
      {
         get { return _x215List; }
         set { _x215List = value; }
      }

      public X217.MessageGroup X217List
      {
         get { return _x217List; }
         set { _x217List = value; }
      }

      public GE FunctionalGroupTrailer
      {
         get { return _functionalGroupTrailer; }
         set { _functionalGroupTrailer = value; }
      }

      public IEA InterchangeControlTrailer
      {
         get { return _interchangeControlTrailer; }
         set { _interchangeControlTrailer = value; }
      }


      public void FormatError()
      {

         //if (_x215List != null) uak = _x215List.GetUAK();
         if (_x217List != null) _x217List.FormatError();

      }

      public bool ValidateMessage()
      {
         bool validMessage = true;

         if (_x215List != null) validMessage = _x215List.ValidateMessage();
         if (_x217List != null) validMessage = _x217List.ValidateMessage();

         return validMessage;
      }

      public string GetUAK()
      {
         string uak = string.Empty;

         if (_x215List != null) uak = _x215List.GetUAK();
         if (_x217List != null) uak = _x217List.GetUAK();

         return uak;
      }

      public void GetPatientInfo(ref string lastName, ref string firstName, ref string ssn, ref DateTime? dateOfBirth)
      {
         if (_x215List != null) _x215List.GetPatientInfo(ref lastName, ref firstName, ref ssn, ref dateOfBirth);
         if (_x217List != null) _x217List.GetPatientInfo(ref lastName, ref firstName, ref ssn, ref dateOfBirth);
      }

      public void GetVendorInfo(ref string vendorTin, ref string vendorName)
      {
         if (_x215List != null) _x215List.GetVendorInfo(ref vendorTin, ref vendorName);
         if (_x217List != null) _x217List.GetVendorInfo(ref vendorTin, ref vendorName);
      }

      public void GetLookupDates(ref DateTime? issueDate, ref DateTime? fromDate, ref DateTime? toDate)
      {
         if (_x215List != null) _x215List.GetLookupDates(ref issueDate, ref fromDate, ref toDate);
         if (_x217List != null) _x217List.GetLookupDates(ref issueDate, ref fromDate, ref toDate);
      }

      public void UpdateUmoDetail(Int16 STATION_CODE, string STATION_NAME)
      {
         if (_x215List != null) _x215List.UpdateUmoDetail(STATION_CODE, STATION_NAME);
         if (_x217List != null) _x217List.UpdateUmoDetail(STATION_CODE, STATION_NAME);
      }

      public void UpdateRequesterDetail()
      {
         if (_x215List != null) _x215List.UpdateRequesterDetail();
         if (_x217List != null) _x217List.UpdateRequesterDetail();
      }

      public void UpdateSubscriberDetail()
      {
         if (_x215List != null) _x215List.UpdateSubscriberDetail();
         if (_x217List != null) _x217List.UpdateSubscriberDetail();
      }

      public void UpdateDependentDetail()
      {
         if (_x215List != null) _x215List.UpdateDependentDetail();
         if (_x217List != null) _x217List.UpdateDependentDetail();
      }

      public void UpdatePatientEventDetail(string UAK, DateTime dateFrom, DateTime dateTo, string services)
      {
         if (_x215List != null) _x215List.UpdatePatientEventDetail(UAK, dateFrom, dateTo, services);
         if (_x217List != null) _x217List.UpdatePatientEventDetail(UAK, dateFrom, dateTo, services);
      }



      public void UpdateServiceDetail()
      {
         if (_x215List != null) _x215List.UpdateServiceDetail();
         if (_x217List != null) _x217List.UpdateServiceDetail();
      }

      public void FormatForResponse()
      {
         if (_x215List != null)
         {
               _x215List.UpdateSegmentIds();
               _x215List.UpdateSegmentCount();
         }

         if (_x217List != null)
         {
               _x217List.UpdateSegmentIds();
               _x217List.UpdateSegmentCount();
         }
      }

      public override string ToString()
      {
         string strReturn = string.Empty;

         if (_interchangeControlHeader != null) strReturn += _interchangeControlHeader.ToString();
         if (_functionalGroupHeader != null) strReturn += _functionalGroupHeader.ToString();
         if (_x215List != null) strReturn += _x215List.ToString();
         if (_x217List != null) strReturn += _x217List.ToString();
         if (_functionalGroupTrailer != null) strReturn += _functionalGroupTrailer.ToString();
         if (_interchangeControlTrailer != null) strReturn += _interchangeControlTrailer.ToString();

         return strReturn;
      }

   }
}
